package meerkat.voting.gui.ui;

/**
 * Created by Laura on 12/12/2016.
 */

import javafx.application.Application;
import javafx.scene.Scene;
import javafx.scene.layout.Pane;
import javafx.stage.Stage;
import meerkat.voting.gui.ui.controllersFX.MainController;
import meerkat.voting.gui.ui.controllersFX.VistaNavigator;
import meerkat.voting.gui.ui.uicommands.StartSessionUICommand;
import meerkat.voting.gui.ui.uicommands.UICommand;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import javafx.scene.Parent;
import javafx.fxml.FXMLLoader;

import java.io.IOException;

public class MainFX extends Application {

    private static final Logger logger = LoggerFactory.getLogger(GraphicalUI.class);

//    @Override
//    public void init() throws Exception {
//        parent.setGraphicalFx(this);
//    }

//    public static void main(String[] args) {
//        launch(args);
//    }

    @Override
    public void start(Stage stage) throws Exception{
        stage.setTitle("Vista Viewer");
        stage.setScene(
                createScene(
                        loadMainPane()
                )
        );
        stage.show();
    }

    /**
     * Loads the main fxml layout.
     * Sets up the vista switching VistaNavigator.
     * Loads the first vista into the fxml layout.
     *
     * @return the loaded pane.
     * @throws IOException if the pane could not be loaded.
     */
    private Pane loadMainPane() throws IOException {
        FXMLLoader loader = new FXMLLoader(getClass().getResource(VistaNavigator.MAIN));

        Pane mainPane = (Pane) loader.load();

        MainController mainController = loader.getController();
        mainController.setCurrentCommand(null);

        VistaNavigator.setMainController(mainController);
        VistaNavigator.loadVista(VistaNavigator.VISTA_1);

        return mainPane;
    }

    /**
     * Creates the main application scene.
     *
     * @param mainPane the main application layout.
     *
     * @return the created scene.
     */
    private Scene createScene(Pane mainPane) {
        Scene scene = new Scene(mainPane);
//        scene.getStylesheets().setAll(
//                getClass().getResource("/views/vista.css").toExternalForm()
//        );
        return scene;
    }

}
