package meerkat.voting.gui.ui.controllersFX;

import javafx.fxml.FXML;
import javafx.scene.control.Button;
import javafx.scene.input.MouseEvent;
import meerkat.protobuf.Voting;
import meerkat.voting.controller.callbacks.VoterCancelThrowable;
import meerkat.voting.gui.ui.UIUtils;
import meerkat.voting.gui.ui.uicommands.ChannelChoiceUICommand;
import meerkat.voting.gui.ui.uicommands.UICommand;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by Vladimir Eliezer Tokarev on 8/27/2016.
 * ChannelChoiceController handle the behavior of select channel section screen
 */
public class ChannelChoiceController {

    private List<Integer> chanelValue;
    private int pointer;
    private boolean lock;

    @FXML
    public void answerWelcomeScreen() {
//        MainFX.parent.answerWelcomeScreen((StartSessionUICommand) MainFX.currentCommand);
    }

    private void nextPane() {
        ChannelChoiceUICommand command = (ChannelChoiceUICommand) VistaNavigator.getCurrentCommand();
        System.out.println("Showing questions for choosing channel:\n");
        try {
            List<Voting.BallotAnswer> answers = askVoterForAnswers(command.getQuestions());
            VistaNavigator.getCurrentCommand().getCallback().onSuccess(answers);
        }
        catch (VoterCancelThrowable e) {
            VistaNavigator.getCurrentCommand().getCallback().onFailure(e);
        }
        catch (IOException e) {
//            String errorMessage = "Channel choice failed due to IOException: " + e;
//            logger.error (errorMessage);
//            System.err.println(errorMessage);
            VistaNavigator.getCurrentCommand().getCallback().onFailure(e);
        }

        //askVoterForAnswers:
        List<Voting.BallotAnswer> answers = new ArrayList<>();
        int index = 0;
        while (index < questions.size()) {
            Voting.BallotQuestion question = questions.get(index);
            System.out.println("Question number " + index);
            showQuestionInConsole(question);

            System.out.println("UI screen: Enter your answer. You can also type '(b)ack' or '(c)ancel' or '(s)kip");
            String s = readInputLine();

            if ((s.equals("cancel") || s.equals("c")) || (index == 0 && (s.equals("back") || s.equals("b")))) {
                throw new VoterCancelThrowable();
            }
            else if (s.equals("back") || s.equals("b")) {
                --index;
                answers.remove(index);
            }
            else if (s.equals("skip") || s.equals("s")) {
                answers.add(UIUtils.translateStringAnswerToProtoBufMessageAnswer(""));
                ++index;
            }
            else {
                answers.add(UIUtils.translateStringAnswerToProtoBufMessageAnswer(s));
                ++index;
            }
        }
        return answers;
    }

    private void ProceedToNameSelection(MouseEvent boutonPressed) {
//        this.currentStage.close();
//        this.currentStage.setScene(this.next.GetCurrentScene());
//        this.next.UpdateNode();
//        this.currentStage.show();
//        this.logger.debug("Created the proceess to name selection object loader.");
    }

//    @Override
    /**
     * Creates the array of the canel value
     */
    public void UpdateNode() {
        this.pointer = 0;
        this.lock = false;

        // created the channel value list
        // every value in the list represents one of the cells values
        this.chanelValue = new ArrayList<>();
        this.chanelValue.add(0);
        this.chanelValue.add(0);
        this.chanelValue.add(0);
        this.chanelValue.add(0);
//        this.logger.debug("Created and filled with zeros the channel value.");

        this.updateVisualChanel();
//        this.UpdateVotersChoise();
    }

    /**
     * Updates the channel in the voters choise
     */
//    private void UpdateVotersChoise(){
//        this.votersBallot.VoterChannel = this.chanelValue;
//    }

    /**
     * Updates the visual channel value
     */
    private void updateVisualChanel(){
        for (int i = 0 ; i < 4 ; i ++ ){
            String id = "#textarea_"+i;
//            TextField textField = ((TextField)this.currentStage.getScene().lookup(id));
//            textField.setText(String.valueOf(this.chanelValue.get(i)));
        }
//        this.logger.debug("Updated the visual representation of the channel (its visual value).");
    }

    @FXML
    private void numberPressed(MouseEvent mousePressed){
        if (!this.lock) {
            String value = ((Button) mousePressed.getSource()).getId().split("_")[1];
            this.chanelValue.set(this.pointer, Integer.parseInt(value));
            this.pointer++;
            this.updateVisualChanel();
//            this.UpdateVotersChoise();
            if (this.pointer == 4) {
                this.lock = true;
            }
//            this.logger.debug("The " + value +" button have been pressed, then this value was pushed to channel value.");
        }
    }

    @FXML
    private void clearLastNumber(MouseEvent mousePressed){
        if (this.pointer >= 1) {
            int lastValueLocation = this.pointer - 1;
            int lastValue = this.chanelValue.get(lastValueLocation);
            this.chanelValue.set(lastValueLocation, 0);
//            this.currentStage.show();
            this.pointer--;
            this.updateVisualChanel();
//            this.UpdateVotersChoise();
            this.lock = false;
//            this.logger.debug("The last value was removed from channel value (the value was " + lastValue + " ).");
        }
    }


}
